unit LDN177u1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  StdCtrls;

const
  bArrX=127;//if set to 63, there will be 64 elements
  bArrY=63;

type

  { TLDN177f1 }

  TLDN177f1 = class(TForm)
    Button1: TButton;
    buQuit: TButton;
    Button2: TButton;
    imgIm: TImage;
    procedure buQuitClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure DrawRect(iX,iY:integer;clDot:TColor);
  private
    clCellColor: array [0..bArrX,0..bArrY] of TColor;
    procedure DrawAll;
    { private declarations }
  public
    { public declarations }
  end;

var
  LDN177f1: TLDN177f1;

implementation

{$R *.lfm}
{$R+}//turn on range checking... ("$R" is something ELSE}

var Bitmap:TBitmap;
  iImLeft,iImTop,iImWidth,iImHeight:integer;

{ TLDN177f1 }

//===========================================================
procedure TLDN177f1.FormCreate(Sender: TObject);
var cX,cY: integer;
begin
  for cX:=0 to bArrX do
  begin
    for cY:=0 to bArrY do
    begin
      clCellColor[cX,cY]:=RGBToColor(random(256),random(256),random(256))
    end;//for xY
  end;//for cX

  iImLeft:=imgIm.left;
  iImTop:=imgIm.top;
  iImWidth:=imgIm.width;
  iImHeight:=imgIm.height;

  Bitmap:=TBitmap.create;
  Bitmap.width:=iImWidth;
  Bitmap.height:=iImHeight;

  imgIm.Canvas.pen.color:=clWhite;
  imgIm.Canvas.Rectangle(0,0,iImWidth,iImHeight);

  randomize;

end;//FormCreate

//===========================================================
procedure TLDN177f1.Button1Click(Sender: TObject);
var cX,cY: integer;
begin
  for cX:=0 to bArrX do
  begin
    for cY:=0 to bArrY do
    begin
      //For the following to work well, bArrX and bArrY need to be
      //   powers-of-two-minus-1, e.g. 31, 63, 128
      clCellColor[cX,cY]:=RGBToColor(cX*(265 div bArrX),
             cY*(265 div bArrY),random(256));
    end;//for xY
  end;//for cX

DrawAll;
end;

procedure TLDN177f1.Button2Click(Sender: TObject);
var cX,cY: integer;
    bRedTmp,bGreenTmp,bBlueTmp:byte;
begin
    for cX:=0 to bArrX do
    begin
      for cY:=0 to bArrY do
      begin
        RedGreenBlue(clCellColor[cX,cY],bRedTmp,bGreenTmp,bBlueTmp);

        if bRedTmp<251 then bRedTmp:=bRedTmp+5//no ; here
          else bRedTmp:=0;
        //bGreenTmp:=;
        //bBlueTmp:=;

        clCellColor[cX,cY]:=RGBToColor(bRedTmp,bGreenTmp,bBlueTmp)
      end;//for xY
    end;//for cX

  DrawAll;

end;

procedure TLDN177f1.buQuitClick(Sender: TObject);
begin
  application.terminate;
end;

//===========================================================
procedure TLDN177f1.FormShow(Sender: TObject);
begin
  DrawAll;
end;//FormShow

//===========================================================
procedure TLDN177f1.DrawRect(iX,iY:integer;clDot:TColor);
  begin
    imgIm.Picture.Bitmap.canvas.pixels[iX,iY]:=clDot;
    imgIm.Picture.Bitmap.canvas.pixels[iX+1,iY]:=clDot;
    imgIm.Picture.Bitmap.canvas.pixels[iX,iY+1]:=clDot;
    imgIm.Picture.Bitmap.canvas.pixels[iX+1,iY+1]:=clDot;
    imgIm.Picture.Bitmap.canvas.pixels[iX,iY+2]:=clDot;
    imgIm.Picture.Bitmap.canvas.pixels[iX+1,iY+2]:=clDot;
    imgIm.Picture.Bitmap.canvas.pixels[iX+2,iY+2]:=clDot;
    imgIm.Picture.Bitmap.canvas.pixels[iX+2,iY]:=clDot;
    imgIm.Picture.Bitmap.canvas.pixels[iX+2,iY+1]:=clDot;
  end;//DrawRect

//===========================================================
procedure TLDN177f1.DrawAll;
var cX,cY: integer;
begin
    for cX:=0 to bArrX do
    begin
      for cY:=0 to bArrY do
      begin
        DrawRect(cX*4,cy*4,clCellColor[cX,cY]);
      end;//for xY
    end;//for cX
end;//DrawAll

end.

